<?php

class MnglOptionsController
{
  function MnglOptionsController()
  {
    add_action('admin_menu', array( $this, 'menu' ));
    add_action('admin_head-toplevel_page_mingle-options', array($this,'head'));
  }
  
  function menu()
  {
    add_menu_page('Mingle', 'Mingle', 8, 'mingle-options', array($this,'route'), MNGL_URL . "/images/mingle_16.png");
  }
  
  function route()
  {
    global $action;
    if($action=='process-form')
      return $this->process_form();
    else
      return $this->display_form();
  }
  
  function head()
  {
    $css_file = 'mngl-options.css';
    $js_file  = 'mngl-options.js';
    require_once(MNGL_VIEWS_PATH . '/shared/admin_head.php');
  }

  function display_form()
  {
    global $mngl_options, $app_helper;
    
    if(!$mngl_options->setup_complete)
      require_once(MNGL_VIEWS_PATH . '/shared/must_configure.php');
    
    require_once(MNGL_VIEWS_PATH . '/mngl-options/form.php');
  }

  function process_form()
  {
    global $mngl_options, $app_helper;
    
    $errors = array();
    
    $errors = $mngl_options->validate($_POST,$errors);
    
    $mngl_options->update($_POST);
    
    if( count($errors) > 0 )
      require(MNGL_VIEWS_PATH . '/shared/errors.php');
    else
    {
      $mngl_options->store();
      require_once(MNGL_VIEWS_PATH . '/mngl-options/options_saved.php');
    }

    if(!$mngl_options->setup_complete)
      require_once(MNGL_VIEWS_PATH . '/shared/must_configure.php');

    require_once(MNGL_VIEWS_PATH . '/mngl-options/form.php');
  }
}
?>
