<?php

class MnglAppHelper
{
  function MnglAppHelper()
  {
  }

  function get_pages()
  {
    global $wpdb;
    
    $query = "SELECT * FROM {$wpdb->prefix}posts WHERE post_status=%s AND post_type=%s";
    
    $query = $wpdb->prepare( $query, "publish", "page" );
    
    $results = $wpdb->get_results( $query );
    
    if($results)
      return $results;
    else
      return array();
  }
  
  // Displays time as in how many seconds / minutes / hours / days / weeks ago
  function time_ago($created_at)
  {
    if($created_at == false)
     return '';

    $ago = time() - strtotime($created_at);
    $ago_str = '';
    
    $minutes = 60;
    $hours   = $minutes * 60;
    $days    = $hours * 24;
    $weeks   = $days * 7;
    $months  = $days * 30;
    $years   = $days * 365;
    
    if($ago < $minutes)
    {
      if($ago == 1)
        $ago_str = "{$ago} second ago";
      else
        $ago_str = "{$ago} seconds ago";
    }
    else if($ago < $hours)
    {
      $ago_minutes = (int)($ago / $minutes);
      
      if($ago_minutes == 1)
        $ago_str = "{$ago_minutes} minute ago";
      else
        $ago_str = "{$ago_minutes} minutes ago";
    }
    else if($ago < $days)
    {
      $ago_hours = (int)($ago / $hours);
      
      if($ago_hours == 1)
        $ago_str = "{$ago_hours} hour ago";
      else
        $ago_str = "{$ago_hours} hours ago";
    }
    else if($ago < $weeks)
    {
      $ago_days = (int)($ago / $days);
      
      if($ago_days == 1)
        $ago_str = "{$ago_days} day ago";
      else
        $ago_str = "{$ago_days} days ago";
    }
    else if($ago < $months)
    {
      $ago_weeks = (int)($ago / $weeks);
      
      if($ago_weeks == 1)
        $ago_str = "{$ago_weeks} week ago";
      else
        $ago_str = "{$ago_weeks} weeks ago";
    }
    else if($ago < $years)
    {
      $ago_months = (int)($ago / $months);
      
      if($ago_months == 1)
        $ago_str = "{$ago_months} month ago";
      else
        $ago_str = "{$ago_months} months ago";
    }
    else
    {
      $ago_years = (int)($ago / $years);
      
      if($ago_years == 1)
        $ago_str = "{$ago_years} year ago";
      else
        $ago_str = "{$ago_years} years ago";
    }
    
    return $ago_str;
  }
  
  function value_is_selected($field_name, $field_value, $selected_value)
  {
    if( (isset($_POST[$field_name]) and $_POST[$field_name] == $selected_value) or
        (!isset($_POST[$field_name]) and $field_value == $selected_value) )
      echo ' selected="selected"';
  }
  
  function value_is_checked($field_name, $field_value)
  {
    if( (isset($_POST) and $_POST[$field_name] == 'on') or
        (!isset($_POST) and $field_value == 'on') )
      echo ' checked="checked"';
  }

  function value_is_checked_with_array($field_name, $index, $field_value)
  {
    if( ( $_POST['action'] == 'process_form' and isset( $_POST[ $field_name ][ $index ] ) ) or
        ( $_POST['action'] != 'process_form' and isset($field_value) ) )
      echo ' checked="checked"';
  }
}

?>