<?php
if(class_exists('WP_Widget'))
{
  class MnglLoginWidget extends WP_Widget {
    /** constructor */
    function MnglLoginWidget() {
      parent::WP_Widget(false, $name = 'Mingle Login');	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {
      global $mngl_options, $mngl_blogurl, $mngl_blogname;	
      extract( $args );
      $title = apply_filters('widget_title', $instance['title']);
      ?>
        <?php echo $before_widget; ?>
        <?php if ( $title )
          echo $before_title . $title . $after_title; ?>
        <?php if (is_user_logged_in()) {
          ?>
          <ul style="list-style-type: none;" class="mngl-login-widget-nav">
            <li><a href="<?php echo get_permalink($mngl_options->activity_page_id); ?>">Activity</a></li>
            <li><a href="<?php echo get_permalink($mngl_options->profile_page_id); ?>">Profile</a></li>
            <li><a href="<?php echo get_permalink($mngl_options->profile_edit_page_id); ?>">Settings</a></li>
            <li><a href="<?php echo get_permalink($mngl_options->friends_page_id); ?>">Friends</a></li>
            <li><a href="<?php echo get_permalink($mngl_options->friend_requests_page_id); ?>">Friend Request</a></li>
            <li><a href="<?php echo get_permalink($mngl_options->directory_page_id); ?>">Directory</a></li>
          </ul>
          <p style="font-size: 10px" class="mngl-logout-button"><a href="<?php echo wp_logout_url(get_permalink($mngl_options->activity_page_id)); ?>">Logout</a></p>
          <?php
        } else { ?>
          <p>Login to connect with Others on <?php echo $mngl_blogname; ?>:</p>
          <form name="loginform" id="loginform" action="<?php echo $mngl_blogurl; ?>/wp-login.php" method="post">
          	<p>
          		<label><strong>Username</strong><br />
          		<input type="text" name="log" id="user_login" class="input" value="" tabindex="10" style="width: 100%; font-size: 12px; padding: 4px;" /></label>
          		<label><strong>Password</strong><br />
          		<input type="password" name="pwd" id="user_pass" class="input" value="" tabindex="20" style="width: 100%; line-height: 12px; padding: 4px;" /></label><br/>
          	  <label><input name="rememberme" type="checkbox" id="rememberme" value="forever" tabindex="90" /> Remember Me</label>
          	</p>
          	<p class="submit">
          		<input type="submit" name="wp-submit" id="wp-submit" class="button-primary form_submit" value="Log In" tabindex="100" />
          		<input type="hidden" name="redirect_to" value="<?php echo get_permalink($mngl_options->activity_page_id); ?>" />
          		<input type="hidden" name="testcookie" value="1" />
          	</p>
          </form>
          <p style="font-size: 10px" class="mngl-login-actions">
          <?php if(get_option('users_can_register')) {
            ?>
              <a href="<?php echo $mngl_blogurl; ?>/wp-login.php?action=register">Register</a>&nbsp;|
            <?php
                }
        ?>
          <a href="<?php echo $mngl_blogurl; ?>/wp-login.php?action=lostpassword">Lost Password?</a>
  <?php } ?>      
        <p style="font-size: 8px;">Powered by <span><img src="<?php echo MNGL_URL . "/images/mingle_16.png"; ?>" alt="Small Mingle Icon" width="10px" height="10px">&nbsp;<a href="http://blairwilliams.com/mingle" style="text-decoration: none;">Mingle</a></span></p>
        <?php echo $after_widget; ?>
      <?php
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
      return $new_instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
      $title = esc_attr($instance['title']);
      ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
      <?php 
    }
  }
}
?>